/* tslint:disable:no-unused-variable */
import { ComponentFixture, TestBed } from '@angular/core/testing';
import { By }             from '@angular/platform-browser';
import { DebugElement }    from '@angular/core';

import { AppComponent } from './app.component';
import {User} from './user';
import {UserService} from './users.service';

let fixture: ComponentFixture<AppComponent>;
let de:      DebugElement;
let el:      HTMLElement;
let userService: UserService;
let userApp: AppComponent;
let spy:    any;
let fakeUsers: User[];

////////  SPECS  /////////////

describe('AppComponent with TCB', () => {
  beforeEach(() => {

    TestBed.configureTestingModule({
      declarations: [AppComponent],
      providers:    [UserService]
    }).compileComponents().then(() => {
        //////// FAKE user service ////////
        fakeUsers = [{"user_id":"0","prenom":"tata","nom":"2000","profil":"Eleve"},
                     {"user_id":"1","prenom":"jojo","nom":"2024","profil":"Prof"},
                     {"user_id":"2","prenom":"marjo","nom":"21","profil":"Bot"}];

        fixture = TestBed.createComponent(AppComponent);
        // UserService from the root injector
        // userService = fixture.debugElement.injector.get(UserService);
        userService = TestBed.get(UserService);
        var spy = spyOn(userService, 'getUsers').and.returnValue(Promise.resolve(fakeUsers));
        userApp = fixture.componentInstance;
        console.log(fixture)
        console.log(userApp)
        //  get the "table" element by CSS selector (e.g., by class name)
        de = fixture.debugElement.query(By.css('.table'));
        el = de.nativeElement;
    });
  });

  it('should instantiate component', () => {
    // let fixture = TestBed.createComponent(AppComponent);
    expect(fixture.componentInstance instanceof AppComponent).toBe(true, 'should create AppComponent');
  });

  it('should not show users before OnInit', () => {
    de = fixture.debugElement.query(By.css('tr.row'));
    console.log(de);
    //el = de.nativeElement;
    //expect(el.textContent).toBe('', 'nothing displayed');
    expect(spy.calls.any()).toBe(false, 'getUsers not yet called');
  });

  it('should have expected <h1> text', () => {
    // let fixture = TestBed.createComponent(AppComponent);
    fixture.detectChanges();

    let h1 = fixture.debugElement.query(el => el.name === 'h1').nativeElement;  // it works

        h1 = fixture.debugElement.query(By.css('h1')).nativeElement;            // preferred

    expect(h1.innerText).toMatch(/angular 2 app/i, '<h1> should say something about "Angular 2 App"');

  // userServiceStub = {
  //   users = fakeUsers,
  //   _index_of(user: User): number {
  //     return users.map(function(user) { return user.user_id; }).indexOf(user.user_id);
  //   },
  //   getUsers(): User[] {
  //     return Promise.resolve(this.users);
  //   },
  //   addUser(user: User): User {
  //     // calculate next index
  //     max_index = number(this.users[this.users.length - 1].user_id);
  //     user.user_id = string(max_index + 1);
  //     this.users.push(user);
  //     return Promise.resolev(user);
  //   },
  //   majUsers(user: User): User {
  //     user_id = this._index_of(user);
  //     this.users[user_id] = user;
  //     return Promise.resolve(user);
  //   },
  //   delUser(user: User): User {
  //     // delete selected user from users
  //     user_id = this._index_of(user);
  //     this.users.splice(user_id, 1);
  //     return Promise.resolve(user);
  //   }
  // }
  // TestBed.configureTestingModule({
  //   declarations: [AppComponent],
  //   providers:    [ {provide: UserService, useValue: userServiceStub } ]
  // }).compileComponents();

  });
});
