import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import {UserService} from './users.service'
import {User} from './user'

@Component({
    selector: 'my-app',
    templateUrl: 'app/users_list.template.html'
})
export class AppComponent implements OnInit {
  users : User[] = [];
  newuser : User;
  constructor(private _userService: UserService){
            this._userService = _userService;
             }
  getUsers(): void {
    this._userService.getUsers()
    .then(users => this.users = users);
  };
  ngOnInit(): void {
    this.getUsers();
    this.newuser = new User();
  };

  MajUser(user: User): void {
    console.log("MajUser", user);
    this._userService.majUser(user)
    .then(user => this.getUsers())
  };

  DelUser(user_id: String) {
    console.log("DelUser", user_id);
    this._userService.delUser(user_id)
    .then(user => this.getUsers())
  }

  AddUser(user: User) {
    console.log("AddUser", user);
    this._userService.addUser(user)
    .then(user => {
      this.newuser = new User()
    })
    .then(user => this.getUsers())
  }

  title = 'Gestion utilisateurs';
}
