import {Injectable} from "@angular/core";

import {Http, RequestOptions, RequestMethod, Headers} from '@angular/http';
import {User} from './user';

import 'rxjs/add/operator/toPromise';

@Injectable()
export class UserService{

   endpoint_url = "http://192.168.0.24:9090/api/users";

   constructor(private http: Http){
      this.http = http;
   }

   getUsers(): Promise<User[]> {
    return this.http.get(this.endpoint_url)
               .toPromise()
               .then(res => res.json() as User[])
               .catch(this.handleError);
   }

   majUser(user: User): Promise<User> {
      console.log("majUser : ", user);
      let headers = new Headers({ 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8' });
      let options = new RequestOptions({ headers: headers });
      return this.http.put(this.endpoint_url+"/"+user.user_id, user)
               .toPromise()
               .then(res => res.json() as User)
               .catch(this.handleError);
   }

   addUser(user: User): Promise<User> {
      console.log("addUser : ", user);
      let headers = new Headers({ 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8' });
      let options = new RequestOptions({ headers: headers });
      return this.http.post(this.endpoint_url, user)
               .toPromise()
               .then(res => res.json() as User)
               .catch(this.handleError);
   }

   delUser(user_id: String): Promise<User> {
      console.log("delUser : ", user_id);
      return this.http.delete(this.endpoint_url+"/"+user_id)
               .toPromise()
               .then(res => res.json() as User)
               .catch(this.handleError);
   }

   private handleError(error: any): Promise<any> {
    console.error('An error occurred', error); // for demo purposes only
    return Promise.reject(error.message || error);
   }

   //~ getUser (user_id){
       //~ return this.http.get(this.endpoint_url + "/" + user_id).map(res => res.json());
   //~ }
}
