# -*- coding: UTF-8 -*-
def user_to_list(user_data):
    key, data = user_data
    user = {'user_id':str(key)}
    user.update(data)
    return user

class Users(object):

    def __init__(self, users):
        self.users = users

    def get_users_list(self):
        all_users = map(user_to_list, self.users.items())
        all_users.sort(key=lambda user:int(user['user_id']))
        return all_users

    def get_user(self, user_id):
        if user_id in self.users:
            return user_to_list((user_id, self.users[user_id]))
        else:
            return {}

    def create_user(self, nom, prenom, profil):
        new_user = {
            'nom': nom,
            'prenom': prenom,
            'profil': profil
        }
        if len(self.users.keys()) == 0:
            index = 0
        else:
            index = max(self.users.keys()) + 1
        self.users[index] = new_user
        return user_to_list((index, self.users[index]))

    def update_user(self, user_id, nom, prenom, profil):
        if user_id in self.users:
            self.users[user_id]['nom'] = nom
            self.users[user_id]['prenom'] = prenom
            self.users[user_id]['profil'] = profil
            return user_to_list((user_id, self.users[user_id]))
        else:
            return {}

    def delete_user(self, user_id):
        if user_id in self.users:
            temp = user_to_list((user_id, self.users[user_id]))
            del(self.users[user_id])
            return temp
        else:
            return {}
