#!/usr/bin/env python
#-*- coding:utf-8 -*-

from flask import Flask
from flask import json
from flask import request
from flask import render_template
from flask import url_for, send_from_directory
from flask_restful import Resource, Api, reqparse
from flask_restful.utils import cors
from lib_users import Users as LibUsers

app = Flask(__name__)
api = Api(app)
api.decorators = [cors.crossdomain(origin='*', headers=['accept', 'Content-Type'])]

parser = reqparse.RequestParser()
parser.add_argument('nom')
parser.add_argument('prenom')
parser.add_argument('profil')

users = {
        0: {
            'nom': u'yoyo',
            'prenom': u'2000',
            'profil': u'Eleve'
            },
        1: {
            'nom': u'jojo',
            'prenom': u'2024',
            'profil': u'Prof'
            },
        2: {
            'nom': u'marjo',
            'prenom': u'21',
            'profil': u'Bot'
            }
}


#@app.before_request
#def request_intercept():
#    print request.data
#    print "ARGS : ", str(request.args)
#    print "DATA : ", request.get_data()
#    print "JSON : ", request.get_json()
#    print "STREAM : ", request.stream.read()
#    print "MIME : ", request.mimetype


@api.resource('/api/users', '/api/users/<int:user_id>')
class Users(Resource):

    methods = ['GET', 'POST', 'PUT', 'DELETE', 'OPTIONS']

    def __init__(self):
        self.libuser = LibUsers(users)

    def get(self, user_id=None):
        if user_id is None:
            return self.libuser.get_users_list()
        else:
            return self.libuser.get_user(user_id)

    def post(self):
        args = parser.parse_args()
        print args
        return self.libuser.create_user(args['nom'], args['prenom'], args['profil']), 201

    def put(self, user_id=None):
        args = parser.parse_args()
        print "PUT DATA : user_id:{}, nom:{}, prenom:{}, profil:{}".format(user_id, args['nom'], args['prenom'], args['profil'])
        return self.libuser.update_user(user_id, args['nom'], args['prenom'], args['profil']), 201
        #response = request.form
        #return libuser.update_user(user_id, response['nom'], response['prenom'], response['profil']), 201

    def delete(self, user_id=None):
        return self.libuser.delete_user(user_id), 201

    def options (self):
        return {'Allow' : 'PUT,GET,DELETE,OPTIONS,POST' }, 200, \
        { 'Access-Control-Allow-Origin': '*', \
          'Access-Control-Allow-Methods' : 'PUT,GET,DELETE,OPTIONS,POST' }

@app.route('/riot')
def riot():
    return render_template('riot.html')

@app.route('/riot2')
def riot2():
    return render_template('riot2.html')

@app.route('/mithril')
def mithril_root():
    return render_template('mithril.html')

@app.route('/polymer')
def polymer_root():
    return render_template('polymer.html')

@app.route('/polytest')
def polymer_test():
    return render_template('polytest.html')

if __name__ == '__main__':
    app.run(debug=True, host="0.0.0.0", port=9090)
