#!/usr/bin/env python
#-*- coding:utf-8 -*-

import json
import poc
import pytest

app = None

def setup_function(function):
    """Appelé avant chaque test
    """
    reload(poc)
    global app
    app = poc.app.test_client()

@pytest.fixture()
def list_users_ini():
    return [
        {
        u'user_id': u'0', 
        u'nom': u'yoyo',
        u'prenom': u'2000',
        u'profil': u'Eleve'
        },
        {
        u'user_id': u'1', 
        u'nom': u'jojo',
        u'prenom': u'2024',
        u'profil': u'Prof'
        },
        {
        u'user_id': u'2', 
        u'nom': u'marjo',
        u'prenom': u'21',
        u'profil': u'Bot'
        }
    ]

@pytest.fixture()
def user_2():
    return {
        'user_id': u'2', 
        'nom': u'marjo',
        'prenom': u'21',
        'profil': u'Bot'
    }

@pytest.fixture()
def data():
    return {
        "nom": u"bruno", 
        "prenom": u"antislash", 
        "profil": u"Expert"
    }

def test_users_get_list(list_users_ini):
    """Liste des utilisateurs
    """
    rv = app.get('/api/users')
    assert json.loads(rv.data) == list_users_ini

def test_users_get(user_2):
    """Obtention d'un utilisateur
    """
    rv = app.get('/api/users/2')
    assert json.loads(rv.data) == user_2

def test_users_add(data):
    """Ajout d'un utilisateur
    """
    user = {
        "user_id": u"3", 
        "nom": u"bruno", 
        "prenom": u"antislash", 
        "profil": u"Expert"
        }
    rv = app.post('/api/users', data=data)
    assert user == json.loads(rv.data)

def test_users_modify(user_2):
    """Modification d'un utilisateur
    """
    data = {}
    data.update(user_2)
    data["nom"] = "barjo"
    user = {
        'user_id': u'2', 
        'nom': u'barjo',
        'prenom': u'21',
        'profil': u'Bot'
        }
    rv = app.put('/api/users/2', data=data)
    assert user == json.loads(rv.data)

def test_users_delete(user_2):
    """Suppression d'un utilisateur
    """
    user = {
        'user_id': u'2', 
        'nom': u'marjo',
        'prenom': u'21',
        'profil': u'Bot'
    }
    rv = app.delete('/api/users/2')
    assert user == json.loads(rv.data)
    rv = app.get('/api/users/2')
    assert json.loads(rv.data) == {}

def test_users_delete_all():
    """Suppression de tous les utilisateurs
    """
    rv = app.delete('/api/users/0')
    rv = app.delete('/api/users/1')
    rv = app.delete('/api/users/2')
    rv = app.get('/api/users')
    assert json.loads(rv.data) == []

def test_users_delete_all_add(data):
    """Suppression de tous les utilisateurs puis ajout d'un nouveau
    """
    test_users_delete_all()
    user = {
        "user_id": u"0", 
        "nom": u"bruno", 
        "prenom": u"antislash", 
        "profil": u"Expert"
        }
    rv = app.post('/api/users', data=data)
    assert user == json.loads(rv.data)
    
